Attribute VB_Name = "basSerial"

Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" ( _
    ByVal lpFileName As String, _
    ByVal dwDesiredAccess As Long, _
    ByVal dwShareMode As Long, _
    lpSecurityAttributes As Any, _
    ByVal dwCreationDisposition As Long, _
    ByVal dwFlagsAndAttributes As Long, _
    ByVal hTemplateFile As Long) As Long

Private Declare Function GetCommState Lib "kernel32" ( _
    ByVal nCid As Long, _
    lpDCB As DCB) As Long

Private Declare Function WriteFile Lib "kernel32" ( _
    ByVal hFile As Long, _
    lpBuffer As Any, _
    ByVal nNumberOfBytesToWrite As Long, _
    lpNumberOfBytesWritten As Long, _
    lpOverlapped As Any) As Long

Private Declare Function ReadFile Lib "kernel32" ( _
    ByVal hFile As Long, _
    lpBuffer As Any, _
    ByVal nNumberOfBytesToRead As Long, _
    lpNumberOfBytesRead As Long, _
    lpOverlapped As Any) As Long

Private Declare Function EscapeCommFunction Lib "kernel32" ( _
    ByVal nCid As Long, _
    ByVal nFunc As Long) As Long

Private Declare Function CloseHandle Lib "kernel32" ( _
    ByVal hObject As Long) As Long

Private Declare Function SetCommState Lib "kernel32" ( _
    ByVal hCommDev As Long, _
    lpDCB As DCB) As Long

Private Declare Function ClearCommError Lib "kernel32" ( _
    ByVal hFile As Long, _
    lpErrors As Long, _
    lpStat As COMSTAT) As Long

Private Declare Function GetLastError Lib "kernel32" () As Long

Private Declare Function GetCommTimeouts Lib "kernel32" ( _
    ByVal hFile As Long, _
    lpCommTimeouts As COMMTIMEOUTS) As Long

Private Declare Function SetCommTimeouts Lib "kernel32" ( _
    ByVal hFile As Long, _
    lpCommTimeouts As COMMTIMEOUTS) As Long

Private Declare Function BuildCommDCB Lib "kernel32" Alias "BuildCommDCBA" ( _
    ByVal lpDef As String, _
    lpDCB As DCB) As Long

'Private Type COMMTIMEOUTS
'        ReadIntervalTimeout As Long
'        ReadTotalTimeoutMultiplier As Long
'        ReadTotalTimeoutConstant As Long
'        WriteTotalTimeoutMultiplier As Long
'        WriteTotalTimeoutConstant As Long
'End Type

Private Type COMSTAT
        fBitFields As Long 'See Comment in Win32API.Txt
        cbInQue As Long
        cbOutQue As Long
End Type

Const GENERIC_READ = &H80000000
Const GENERIC_WRITE = &H40000000
Const OPEN_EXISTING = 3
Const INVALID_HANDLE_VALUE = -1
Const SETRTS = 3 '  Set RTS high
Const CLRRTS = 4 '  Set RTS low
Const SETDTR = 5 '  Set DTR high
Const CLRDTR = 6 '  Set DTR low

Private Type DCB
  DCBlength As Long
  BaudRate As Long
  fBitFields As Long 'See Comments in Win32API.Txt
  wReserved As Integer
  XonLim As Integer
  XoffLim As Integer
  ByteSize As Byte
  Parity As Byte
  StopBits As Byte
  XonChar As Byte
  XoffChar As Byte
  ErrorChar As Byte
  EofChar As Byte
  EvtChar As Byte
  wReserved1 As Integer 'Reserved; Do Not Use
End Type


' big version with size 80 ????
'typedef struct _DCB {
'    DWORD DCBlength;      /* sizeof(DCB)                     */
'    DWORD BaudRate;       /* Baudrate at which running       */
'    DWORD fBinary: 1;     /* Binary Mode (skip EOF check)    */
'    DWORD fParity: 1;     /* Enable parity checking          */
'    DWORD fOutxCtsFlow:1; /* CTS handshaking on output       */
'    DWORD fOutxDsrFlow:1; /* DSR handshaking on output       */
'    DWORD fDtrControl:2;  /* DTR Flow control                */
'    DWORD fDsrSensitivity:1; /* DSR Sensitivity              */
'    DWORD fTXContinueOnXoff: 1; /* Continue TX when Xoff sent */
'    DWORD fOutX: 1;       /* Enable output X-ON/X-OFF        */
'    DWORD fInX: 1;        /* Enable input X-ON/X-OFF         */
'    DWORD fErrorChar: 1;  /* Enable Err Replacement          */
'    DWORD fNull: 1;       /* Enable Null stripping           */
'    DWORD fRtsControl:2;  /* Rts Flow control                */
'    DWORD fAbortOnError:1; /* Abort all reads and writes on Error */
'    DWORD fDummy2:17;     /* Reserved                        */
'    WORD wReserved;       /* Not currently used              */
'    WORD XonLim;          /* Transmit X-ON threshold         */
'    WORD XoffLim;         /* Transmit X-OFF threshold        */
'    BYTE ByteSize;        /* Number of bits/byte, 4-8        */
'    BYTE Parity;          /* 0-4=None,Odd,Even,Mark,Space    */
'    BYTE StopBits;        /* 0,1,2 = 1, 1.5, 2               */
'    char XonChar;         /* Tx and Rx X-ON character        */
'    char XoffChar;        /* Tx and Rx X-OFF character       */
'    char ErrorChar;       /* Error replacement char          */
'    char EofChar;         /* End of Input character          */
'    char EvtChar;         /* Received Event character        */
'    WORD wReserved1;      /* Fill for now.                   */
'} DCB, *LPDCB;
'


'Private Type DCB
'  DCBlength As Long
'  BaudRate As Long
'  fBinary As Long
'  fParity As Long
'  fOutxCtsFlow As Long
'  fOutxDsrFlow As Long
'  fDtrControl As Long
'  fDsrSensitivity As Long
'  fTXContinueOnXoff As Long
'  fOutX As Long
'  fInX As Long
'  fErrorChar As Long
'  fNull As Long
'  fRtsControl As Long
'  fAbortOnError As Long
'  fDummy2 As Long
'  wReserved As Integer
'  XonLim As Integer
'  XoffLim As Integer
'  ByteSize As Byte
'  Parity As Byte
'  StopBits As Byte
'  XonChar As Byte
'  XoffChar As Byte
'  ErrorChar As Byte
'  EofChar As Byte
'  EvtChar As Byte
'  wReserved1 As Integer ' reserved; do not use
'End Type

Private Type COMMTIMEOUTS
  ReadIntervalTimeout As Long
  ReadTotalTimeoutMultiplier As Long
  ReadTotalTimeoutConstant As Long
  WriteTotalTimeoutMultiplier As Long
  WriteTotalTimeoutConstant As Long
End Type













Private Type Buffer
    b(31) As Byte
End Type

Dim hSerial As Long



Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Public Type OVERLAPPED
  Internal As Long
  InternalHigh As Long
  offset As Long
  OffsetHigh As Long
  hEvent As Long
End Type

Private Declare Function GetOverlappedResult Lib "kernel32" (ByVal hFile As Long, lpOverlapped As OVERLAPPED, lpNumberOfBytesTransferred As Long, ByVal bWait As Long) As Long

Dim ovRW As OVERLAPPED

Public Declare Function CreateEvent Lib "kernel32" Alias "CreateEventA" (lpEventAttributes As Any, ByVal bManualReset As Long, ByVal bInitialState As Long, ByVal lpName As String) As Long
Public Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long



Public Const WAIT_OBJECT_0 As Long = &H0
Public Const WAIT_ABANDONED As Long = &H80
Public Const WAIT_IO_COMPLETION As Long = &HC0
Public Const WAIT_TIMEOUT As Long = &H102


Public Const ERROR_IO_PENDING = 997 '  dderror

Function CloseSerialPort()

  Call CloseHandle(hSerial)
  
  hSerial = -1

End Function

Function OpenSerialPort(PortNumber As Long, BitRate As Long) As Boolean

  Dim MyDCB As DCB
  Dim Cto As COMMTIMEOUTS
  Dim r As Boolean
  Dim b As Buffer
  Dim errors As Long
  Dim BytesWritten As Long, BytesRead As Long
  Dim i As Long
  Dim PortName As String
  
  PortName = "\\.\COM" & Format$(PortNumber)
  
  hSerial = CreateFile(PortName, GENERIC_READ Or GENERIC_WRITE, 0, ByVal 0&, OPEN_EXISTING, file_flag_overlapped, 0)
  
  If hSerial = INVALID_HANDLE_VALUE Then
    Call MsgBox("Error " & Format$(Err.LastDllError) & " opening COM" & Format$(PortNumber), vbExclamation)
    Exit Function
  End If
  
  
  'http://www.bcb-box.de/Informationen/RS232/rs232.html
  
  ' "1200,n,7,2"
  Dim InitString As String
  
  InitString = "baud=" & Format$(BitRate) & " parity=n data=7 stop=2 xon=off odsr=off octs=off dtr=off rts=off idsr=off "
  
  r = BuildCommDCB(InitString, MyDCB)
  
  
  MyDCB.DCBlength = LenB(MyDCB)  ' 28 works, 80 does not (???)
  
  MyDCB.BaudRate = BitRate
  MyDCB.ByteSize = 7
  'MyDCB.fBinary = 1
  'MyDCB.fParity = 0
  MyDCB.StopBits = 2
  
  MyDCB.XonChar = &H11
  MyDCB.XoffChar = &H13
  MyDCB.XonLim = 1024
  MyDCB.XoffLim = 1024
  
  'MyDCB.fDtrControl = 0 'DTR_CONTROL_DISABLE
  'MyDCB.fRtsControl = 0 'RTS_CONTROL_DISABLE
  
  r = SetCommState(hSerial, MyDCB)
  
  Call EscapeCommFunction(hSerial, SETDTR Or CLRRTS)   ';  // RTS & DTR einschalten

  'Cto.ReadIntervalTimeout = &HFFFF
  'Cto.ReadTotalTimeoutMultiplier = 0
  'Cto.ReadTotalTimeoutConstant = 0
  
  'r = SetCommTimeouts(hSerial, Cto)
  
  '// Timeout bearbeiten
  r = GetCommTimeouts(hSerial, Cto)
  Cto.ReadTotalTimeoutConstant = 100
  Cto.ReadTotalTimeoutMultiplier = 0
  Cto.WriteTotalTimeoutMultiplier = 0
  Cto.WriteTotalTimeoutConstant = 0
  Call SetCommTimeouts(hSerial, Cto)
  
  OpenSerialPort = True
  
End Function

Function ReadSerialPort() As String

  Dim res As Long, BytesRead As Long
  Dim i As Long, s As String, idx As Long
  
  Dim b(32) As Byte
  
  res = ReadFile(hSerial, b(idx), 32, BytesRead, ByVal 0&)

  Debug.Print "ReadFile  res=" & Format$(res) & "  read=" & Format$(BytesRead)

  If BytesRead > 0 Then
    For i = 0 To BytesRead - 1
      s = s & Chr(b(i))
    Next
  End If

  'Debug.Print Now, BytesRead, s
  
  ReadSerialPort = s

End Function


Function WriteSerialPort(s As String) As Boolean

  Dim res As Long, BytesWritten As Long
  Dim i As Long, l As Long
  Dim b() As Byte
  
  l = Len(s)
  
  ReDim b(l)
  
  For i = 0 To l - 1
    b(i) = Asc(Mid$(s, i + 1, 1))
  Next i
  
  res = WriteFile(hSerial, b(0), Len(s), BytesWritten, ByVal 0&)

  WriteSerialPort = (res = 1)

End Function


